﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.display.LoaderInfo;
	import flash.text.TextField;
	import flash.net.URLRequest;
	import flash.events.IOErrorEvent;
	import flash.display.Loader;
	import flash.events.FocusEvent;
	import com.as3facile.utils.text.TextDefil;
	import com.as3facile.DefaultButton;
	
	import com.actionscriptfacile.ui.text.UITextField;

	
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	
	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTextDefilUtils : TextDefil;
		private var oTxtInput : UITextField;
		private var oTxtInputSpeed : UITextField;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			
			// chargement des polices partagées
			//------------------------
			var _loader:Loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler );
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, errorHandler );
			
			//var sFont:String = "http://www.actionscript-facile.com/ressources/swf/FDT/fonts.swf?r="+Math.random()*28;
			var sFont:String = "fonts.swf?r="+Math.random()*28;
			MonsterDebugger.trace(this, "url : "+sFont); 

			var file:URLRequest =  new URLRequest(sFont);
			_loader.load(file );
		}


		/**
		 * Création de l'interface utilisateur.
		 * 
		 */
		private function setupUI() : void
		{
			oTxtInput = this.addText("Renseignez le texte qui va défiler...");
			oTxtInput.x = 30;
			oTxtInput.y = 30;
			oTxtInput.autoSizeNone();
			oTxtInput.multiline = true;
			oTxtInput.maxHeight = oTxtInput.height = 100;
			oTxtInput.maxWidth = oTxtInput.width = 490;
			oTxtInput.border = true;
			oTxtInput.borderColor = 0X006f77;
			oTxtInput.changeFormat("size", 15);// changement de la taille de la police du texte
			oTxtInput.convertToInput();
			oTxtInput.selectable = true;
			this.addChild(oTxtInput);
			
			
			oTxtInputSpeed = this.addText("Vitesse de défilement (en ms) :");
			oTxtInputSpeed.x = oTxtInput.x;
			oTxtInputSpeed.y = oTxtInput.y + oTxtInput.maxHeight + 10;
			
			// mets à jour le champ texte sur le focus, l'utilisateur clique dessus.
			oTxtInputSpeed.addEventListener(FocusEvent.FOCUS_IN, onResetText);
			oTxtInputSpeed.autoSizeNone();
			oTxtInputSpeed.maxWidth = oTxtInputSpeed.width = 180;
			oTxtInputSpeed.border = true;
			oTxtInputSpeed.borderColor = 0x006f77;
			oTxtInputSpeed.changeFormat("size", 12);// changement de la taille de la police du texte
			oTxtInputSpeed.convertToInput();
			oTxtInputSpeed.selectable = true;
			this.addChild(oTxtInputSpeed);
			
			
			var oTxtForDefil:UITextField = this.addText("Cliquez ci-dessus pour lancer le défilement du texte !");
			oTxtForDefil.x = oTxtInput.x;
			oTxtForDefil.y = oTxtInput.y + oTxtInput.maxHeight + 60;
			oTxtForDefil.changeFormat("font", "fiolexGirls");
			oTxtForDefil.changeFormat("size", 34);// changement de la taille de la police du texte
			oTxtForDefil.changeFormat("color",  Math.random() * 0x006f77);
			oTxtForDefil.embedFonts = true;// pour activer les polices embarquées
			this.addChild(oTxtForDefil);
			oTextDefilUtils = new TextDefil(oTxtForDefil);		
			oTextDefilUtils.setSpeed(34);
			
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "C'est parti !";
			oBtnStart.getObject().x = 230;
			oBtnStart.getObject().y = oTxtInput.y + oTxtInput.maxHeight + 20;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onTxtDefil );
			this.addChild(oBtnStart);
		}

		
		/**
		 * Utilisation des polices partagées dynamiques
		 * 
		 */
		private function completeHandler(event : Event) : void
		{
			MonsterDebugger.trace(this, "completeHandler");
			this.setupUI();
		}
		
		/**
		 * Gestion des erreurs de chargement.
		 * 
		 */
		private function errorHandler(e:IOErrorEvent):void 
		{
			MonsterDebugger.trace(this,"erreur de chargement : " + e.text);
			
			var contentLoaderInfo:LoaderInfo = LoaderInfo( e.target);
			contentLoaderInfo.removeEventListener(Event.COMPLETE, completeHandler );
			contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, errorHandler );
			
			
			var text:TextField = addChild( new TextField() ) as TextField;
			text.width = stage.stageWidth;
			text.autoSize = 'center';
			text.text = "Erreur de chargement : "+e.text;
		}
		
		
		/**
		 * Appel lorsque l'utilisateur clique sur le texte 'choix de la vitesse de défilement'.
		 * 
		 */
		private function onResetText(event : FocusEvent) : void
		{
			UITextField(event.target).text = "";
		}



		/**
		 * Affiche un texte défilant.
		 * 
		 */
		private function onTxtDefil(event : Event) : void
		{
			MonsterDebugger.trace(this, "Start onTxtDefil");
			if( Number(oTxtInputSpeed.text) > 0 )	oTextDefilUtils.setSpeed( Number(oTxtInputSpeed.text) );
			oTextDefilUtils.startDefil( oTxtInput.text );
		}

		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 13);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0X006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		
	}
}
