/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package com.as3facile.utils.text
{
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.text.TextField;
	
	
	/**
	 * Permet d'afficher un texte avec un effet de défilement.
	 * 
	 * @author Matthieu
	 */
	public class TextDefil
	{
		private var oText : TextField;
		private var sTextInput : String;
		
		private var oTimer : Timer;
		
		private var nIndex : int;
		private var sTxtDefil : String;
		
		
		/**
		 * Constructeur.
		 * 
		 * @param txtDefil : l'objet TextField pré-configuré qui recevra le texte à afficher.
		 * 
		 */
		public function TextDefil(txtDefil:TextField) 
		{
			oText = txtDefil;
			oTimer = new Timer (95);// vitesse de défilement de 95 ms par défaut
			oTimer.addEventListener (TimerEvent.TIMER, onDefilTxt);
		}


		/**
		 * Affiche le texte petit à petit.
		 * Possibilité d'ajouter d'autrse effets sur le texte.
		 * 
		 */
		private function onDefilTxt(event : TimerEvent) : void
		{
			sTxtDefil += sTextInput.charAt (nIndex); // ajoute les caractères un par un au texte complet
			oText.text = sTxtDefil;// mise à jour du texte
			nIndex++;// caractère suivant
			
			// une fois que la phrase est affichée entièrement, arrêt du Timer
			if (nIndex == sTextInput.length) oTimer.stop();
		}
		
		
		/**
		 * Lance l'affichage du texte, lettre une par une.
		 * @param value : le texte à afficher.
		 * 
		 */
		public function startDefil(value:String):void
		{
			sTextInput = value;
			oText.text = sTxtDefil = "";
			nIndex = 0;
			oTimer.start();
		}
		
		
		/**
		 * Arrête le défilement du texte.
		 * 
		 */
		public function stopDefil():void
		{
			oTimer.stop();
		}
		
		
		
		/**
		 * Vitesse de défilement en ms.
		 * 
		 */
		public function setSpeed(value:Number) : void
		{
			oTimer.delay = value;
		}
		
		
		
		/**
		 * Détruit l'objet proprement.
		 * 
		 */
		public function destroy() : void
		{
			oTimer.removeEventListener (TimerEvent.TIMER, onDefilTxt);
		}
		
	}
}
